#include "qemu/osdep.h"
#include "exec/gdbstub.h"

const GDBFeature gdb_static_features[] = {
    {
        "avr-cpu.xml",
        "<?xml version=\"1.0\"?>\n"
        "<!-- Copyright (C) 2018-2019 Free Software Foundation, Inc.\n"
        "\n"
        "     Copying and distribution of this file, with or without modification,\n"
        "     are permitted in any medium without royalty provided the copyright\n"
        "     notice and this notice are preserved.  -->\n"
        "\n"
        "<!-- Register numbers are hard-coded in order to maintain backward\n"
        "     compatibility with older versions of tools that didn't use xml\n"
        "     register descriptions.  -->\n"
        "\n"
        "<!DOCTYPE feature SYSTEM \"gdb-target.dtd\">\n"
        "<feature name=\"org.gnu.gdb.riscv.cpu\">\n"
        "  <reg name=\"r0\" bitsize=\"8\" type=\"int\" regnum=\"0\"/>\n"
        "  <reg name=\"r1\" bitsize=\"8\" type=\"int\"/>\n"
        "  <reg name=\"r2\" bitsize=\"8\" type=\"int\"/>\n"
        "  <reg name=\"r3\" bitsize=\"8\" type=\"int\"/>\n"
        "  <reg name=\"r4\" bitsize=\"8\" type=\"int\"/>\n"
        "  <reg name=\"r5\" bitsize=\"8\" type=\"int\"/>\n"
        "  <reg name=\"r6\" bitsize=\"8\" type=\"int\"/>\n"
        "  <reg name=\"r7\" bitsize=\"8\" type=\"int\"/>\n"
        "  <reg name=\"r8\" bitsize=\"8\" type=\"int\"/>\n"
        "  <reg name=\"r9\" bitsize=\"8\" type=\"int\"/>\n"
        "  <reg name=\"r10\" bitsize=\"8\" type=\"int\"/>\n"
        "  <reg name=\"r11\" bitsize=\"8\" type=\"int\"/>\n"
        "  <reg name=\"r12\" bitsize=\"8\" type=\"int\"/>\n"
        "  <reg name=\"r13\" bitsize=\"8\" type=\"int\"/>\n"
        "  <reg name=\"r14\" bitsize=\"8\" type=\"int\"/>\n"
        "  <reg name=\"r15\" bitsize=\"8\" type=\"int\"/>\n"
        "  <reg name=\"r16\" bitsize=\"8\" type=\"int\"/>\n"
        "  <reg name=\"r17\" bitsize=\"8\" type=\"int\"/>\n"
        "  <reg name=\"r18\" bitsize=\"8\" type=\"int\"/>\n"
        "  <reg name=\"r19\" bitsize=\"8\" type=\"int\"/>\n"
        "  <reg name=\"r20\" bitsize=\"8\" type=\"int\"/>\n"
        "  <reg name=\"r21\" bitsize=\"8\" type=\"int\"/>\n"
        "  <reg name=\"r22\" bitsize=\"8\" type=\"int\"/>\n"
        "  <reg name=\"r23\" bitsize=\"8\" type=\"int\"/>\n"
        "  <reg name=\"r24\" bitsize=\"8\" type=\"int\"/>\n"
        "  <reg name=\"r25\" bitsize=\"8\" type=\"int\"/>\n"
        "  <reg name=\"r26\" bitsize=\"8\" type=\"int\"/>\n"
        "  <reg name=\"r27\" bitsize=\"8\" type=\"int\"/>\n"
        "  <reg name=\"r28\" bitsize=\"8\" type=\"int\"/>\n"
        "  <reg name=\"r29\" bitsize=\"8\" type=\"int\"/>\n"
        "  <reg name=\"r30\" bitsize=\"8\" type=\"int\"/>\n"
        "  <reg name=\"r31\" bitsize=\"8\" type=\"int\"/>\n"
        "  <reg name=\"sreg\" bitsize=\"8\" type=\"int\"/>\n"
        "  <reg name=\"sp\" bitsize=\"8\" type=\"int\"/>\n"
        "  <reg name=\"pc\" bitsize=\"8\" type=\"int\"/>\n"
        "</feature>\n",
        35,
    },
    { NULL }
};
