#include "qemu/osdep.h"
#include "exec/gdbstub.h"

const GDBFeature gdb_static_features[] = {
    {
        "loongarch-base32.xml",
        "<?xml version=\"1.0\"?>\n"
        "<!-- Copyright (C) 2022 Free Software Foundation, Inc.\n"
        "\n"
        "     Copying and distribution of this file, with or without modification,\n"
        "     are permitted in any medium without royalty provided the copyright\n"
        "     notice and this notice are preserved.  -->\n"
        "\n"
        "<!DOCTYPE feature SYSTEM \"gdb-target.dtd\">\n"
        "<feature name=\"org.gnu.gdb.loongarch.base\">\n"
        "  <reg name=\"r0\" bitsize=\"32\" type=\"uint32\" group=\"general\"/>\n"
        "  <reg name=\"r1\" bitsize=\"32\" type=\"code_ptr\" group=\"general\"/>\n"
        "  <reg name=\"r2\" bitsize=\"32\" type=\"data_ptr\" group=\"general\"/>\n"
        "  <reg name=\"r3\" bitsize=\"32\" type=\"data_ptr\" group=\"general\"/>\n"
        "  <reg name=\"r4\" bitsize=\"32\" type=\"uint32\" group=\"general\"/>\n"
        "  <reg name=\"r5\" bitsize=\"32\" type=\"uint32\" group=\"general\"/>\n"
        "  <reg name=\"r6\" bitsize=\"32\" type=\"uint32\" group=\"general\"/>\n"
        "  <reg name=\"r7\" bitsize=\"32\" type=\"uint32\" group=\"general\"/>\n"
        "  <reg name=\"r8\" bitsize=\"32\" type=\"uint32\" group=\"general\"/>\n"
        "  <reg name=\"r9\" bitsize=\"32\" type=\"uint32\" group=\"general\"/>\n"
        "  <reg name=\"r10\" bitsize=\"32\" type=\"uint32\" group=\"general\"/>\n"
        "  <reg name=\"r11\" bitsize=\"32\" type=\"uint32\" group=\"general\"/>\n"
        "  <reg name=\"r12\" bitsize=\"32\" type=\"uint32\" group=\"general\"/>\n"
        "  <reg name=\"r13\" bitsize=\"32\" type=\"uint32\" group=\"general\"/>\n"
        "  <reg name=\"r14\" bitsize=\"32\" type=\"uint32\" group=\"general\"/>\n"
        "  <reg name=\"r15\" bitsize=\"32\" type=\"uint32\" group=\"general\"/>\n"
        "  <reg name=\"r16\" bitsize=\"32\" type=\"uint32\" group=\"general\"/>\n"
        "  <reg name=\"r17\" bitsize=\"32\" type=\"uint32\" group=\"general\"/>\n"
        "  <reg name=\"r18\" bitsize=\"32\" type=\"uint32\" group=\"general\"/>\n"
        "  <reg name=\"r19\" bitsize=\"32\" type=\"uint32\" group=\"general\"/>\n"
        "  <reg name=\"r20\" bitsize=\"32\" type=\"uint32\" group=\"general\"/>\n"
        "  <reg name=\"r21\" bitsize=\"32\" type=\"uint32\" group=\"general\"/>\n"
        "  <reg name=\"r22\" bitsize=\"32\" type=\"data_ptr\" group=\"general\"/>\n"
        "  <reg name=\"r23\" bitsize=\"32\" type=\"uint32\" group=\"general\"/>\n"
        "  <reg name=\"r24\" bitsize=\"32\" type=\"uint32\" group=\"general\"/>\n"
        "  <reg name=\"r25\" bitsize=\"32\" type=\"uint32\" group=\"general\"/>\n"
        "  <reg name=\"r26\" bitsize=\"32\" type=\"uint32\" group=\"general\"/>\n"
        "  <reg name=\"r27\" bitsize=\"32\" type=\"uint32\" group=\"general\"/>\n"
        "  <reg name=\"r28\" bitsize=\"32\" type=\"uint32\" group=\"general\"/>\n"
        "  <reg name=\"r29\" bitsize=\"32\" type=\"uint32\" group=\"general\"/>\n"
        "  <reg name=\"r30\" bitsize=\"32\" type=\"uint32\" group=\"general\"/>\n"
        "  <reg name=\"r31\" bitsize=\"32\" type=\"uint32\" group=\"general\"/>\n"
        "  <reg name=\"orig_a0\" bitsize=\"32\" type=\"uint32\" group=\"general\"/>\n"
        "  <reg name=\"pc\" bitsize=\"32\" type=\"code_ptr\" group=\"general\"/>\n"
        "  <reg name=\"badv\" bitsize=\"32\" type=\"code_ptr\" group=\"general\"/>\n"
        "</feature>\n",
        35,
    },
    {
        "loongarch-base64.xml",
        "<?xml version=\"1.0\"?>\n"
        "<!-- Copyright (C) 2022 Free Software Foundation, Inc.\n"
        "\n"
        "     Copying and distribution of this file, with or without modification,\n"
        "     are permitted in any medium without royalty provided the copyright\n"
        "     notice and this notice are preserved.  -->\n"
        "\n"
        "<!DOCTYPE feature SYSTEM \"gdb-target.dtd\">\n"
        "<feature name=\"org.gnu.gdb.loongarch.base\">\n"
        "  <reg name=\"r0\" bitsize=\"64\" type=\"uint64\" group=\"general\"/>\n"
        "  <reg name=\"r1\" bitsize=\"64\" type=\"code_ptr\" group=\"general\"/>\n"
        "  <reg name=\"r2\" bitsize=\"64\" type=\"data_ptr\" group=\"general\"/>\n"
        "  <reg name=\"r3\" bitsize=\"64\" type=\"data_ptr\" group=\"general\"/>\n"
        "  <reg name=\"r4\" bitsize=\"64\" type=\"uint64\" group=\"general\"/>\n"
        "  <reg name=\"r5\" bitsize=\"64\" type=\"uint64\" group=\"general\"/>\n"
        "  <reg name=\"r6\" bitsize=\"64\" type=\"uint64\" group=\"general\"/>\n"
        "  <reg name=\"r7\" bitsize=\"64\" type=\"uint64\" group=\"general\"/>\n"
        "  <reg name=\"r8\" bitsize=\"64\" type=\"uint64\" group=\"general\"/>\n"
        "  <reg name=\"r9\" bitsize=\"64\" type=\"uint64\" group=\"general\"/>\n"
        "  <reg name=\"r10\" bitsize=\"64\" type=\"uint64\" group=\"general\"/>\n"
        "  <reg name=\"r11\" bitsize=\"64\" type=\"uint64\" group=\"general\"/>\n"
        "  <reg name=\"r12\" bitsize=\"64\" type=\"uint64\" group=\"general\"/>\n"
        "  <reg name=\"r13\" bitsize=\"64\" type=\"uint64\" group=\"general\"/>\n"
        "  <reg name=\"r14\" bitsize=\"64\" type=\"uint64\" group=\"general\"/>\n"
        "  <reg name=\"r15\" bitsize=\"64\" type=\"uint64\" group=\"general\"/>\n"
        "  <reg name=\"r16\" bitsize=\"64\" type=\"uint64\" group=\"general\"/>\n"
        "  <reg name=\"r17\" bitsize=\"64\" type=\"uint64\" group=\"general\"/>\n"
        "  <reg name=\"r18\" bitsize=\"64\" type=\"uint64\" group=\"general\"/>\n"
        "  <reg name=\"r19\" bitsize=\"64\" type=\"uint64\" group=\"general\"/>\n"
        "  <reg name=\"r20\" bitsize=\"64\" type=\"uint64\" group=\"general\"/>\n"
        "  <reg name=\"r21\" bitsize=\"64\" type=\"uint64\" group=\"general\"/>\n"
        "  <reg name=\"r22\" bitsize=\"64\" type=\"data_ptr\" group=\"general\"/>\n"
        "  <reg name=\"r23\" bitsize=\"64\" type=\"uint64\" group=\"general\"/>\n"
        "  <reg name=\"r24\" bitsize=\"64\" type=\"uint64\" group=\"general\"/>\n"
        "  <reg name=\"r25\" bitsize=\"64\" type=\"uint64\" group=\"general\"/>\n"
        "  <reg name=\"r26\" bitsize=\"64\" type=\"uint64\" group=\"general\"/>\n"
        "  <reg name=\"r27\" bitsize=\"64\" type=\"uint64\" group=\"general\"/>\n"
        "  <reg name=\"r28\" bitsize=\"64\" type=\"uint64\" group=\"general\"/>\n"
        "  <reg name=\"r29\" bitsize=\"64\" type=\"uint64\" group=\"general\"/>\n"
        "  <reg name=\"r30\" bitsize=\"64\" type=\"uint64\" group=\"general\"/>\n"
        "  <reg name=\"r31\" bitsize=\"64\" type=\"uint64\" group=\"general\"/>\n"
        "  <reg name=\"orig_a0\" bitsize=\"64\" type=\"uint64\" group=\"general\"/>\n"
        "  <reg name=\"pc\" bitsize=\"64\" type=\"code_ptr\" group=\"general\"/>\n"
        "  <reg name=\"badv\" bitsize=\"64\" type=\"code_ptr\" group=\"general\"/>\n"
        "</feature>\n",
        35,
    },
    {
        "loongarch-fpu.xml",
        "<?xml version=\"1.0\"?>\n"
        "<!-- Copyright (C) 2021 Free Software Foundation, Inc.\n"
        "\n"
        "     Copying and distribution of this file, with or without modification,\n"
        "     are permitted in any medium without royalty provided the copyright\n"
        "     notice and this notice are preserved.  -->\n"
        "\n"
        "<!DOCTYPE feature SYSTEM \"gdb-target.dtd\">\n"
        "<feature name=\"org.gnu.gdb.loongarch.fpu\">\n"
        "\n"
        "  <union id=\"fputype\">\n"
        "    <field name=\"f\" type=\"ieee_single\"/>\n"
        "    <field name=\"d\" type=\"ieee_double\"/>\n"
        "  </union>\n"
        "\n"
        "  <reg name=\"f0\" bitsize=\"64\" type=\"fputype\" group=\"float\"/>\n"
        "  <reg name=\"f1\" bitsize=\"64\" type=\"fputype\" group=\"float\"/>\n"
        "  <reg name=\"f2\" bitsize=\"64\" type=\"fputype\" group=\"float\"/>\n"
        "  <reg name=\"f3\" bitsize=\"64\" type=\"fputype\" group=\"float\"/>\n"
        "  <reg name=\"f4\" bitsize=\"64\" type=\"fputype\" group=\"float\"/>\n"
        "  <reg name=\"f5\" bitsize=\"64\" type=\"fputype\" group=\"float\"/>\n"
        "  <reg name=\"f6\" bitsize=\"64\" type=\"fputype\" group=\"float\"/>\n"
        "  <reg name=\"f7\" bitsize=\"64\" type=\"fputype\" group=\"float\"/>\n"
        "  <reg name=\"f8\" bitsize=\"64\" type=\"fputype\" group=\"float\"/>\n"
        "  <reg name=\"f9\" bitsize=\"64\" type=\"fputype\" group=\"float\"/>\n"
        "  <reg name=\"f10\" bitsize=\"64\" type=\"fputype\" group=\"float\"/>\n"
        "  <reg name=\"f11\" bitsize=\"64\" type=\"fputype\" group=\"float\"/>\n"
        "  <reg name=\"f12\" bitsize=\"64\" type=\"fputype\" group=\"float\"/>\n"
        "  <reg name=\"f13\" bitsize=\"64\" type=\"fputype\" group=\"float\"/>\n"
        "  <reg name=\"f14\" bitsize=\"64\" type=\"fputype\" group=\"float\"/>\n"
        "  <reg name=\"f15\" bitsize=\"64\" type=\"fputype\" group=\"float\"/>\n"
        "  <reg name=\"f16\" bitsize=\"64\" type=\"fputype\" group=\"float\"/>\n"
        "  <reg name=\"f17\" bitsize=\"64\" type=\"fputype\" group=\"float\"/>\n"
        "  <reg name=\"f18\" bitsize=\"64\" type=\"fputype\" group=\"float\"/>\n"
        "  <reg name=\"f19\" bitsize=\"64\" type=\"fputype\" group=\"float\"/>\n"
        "  <reg name=\"f20\" bitsize=\"64\" type=\"fputype\" group=\"float\"/>\n"
        "  <reg name=\"f21\" bitsize=\"64\" type=\"fputype\" group=\"float\"/>\n"
        "  <reg name=\"f22\" bitsize=\"64\" type=\"fputype\" group=\"float\"/>\n"
        "  <reg name=\"f23\" bitsize=\"64\" type=\"fputype\" group=\"float\"/>\n"
        "  <reg name=\"f24\" bitsize=\"64\" type=\"fputype\" group=\"float\"/>\n"
        "  <reg name=\"f25\" bitsize=\"64\" type=\"fputype\" group=\"float\"/>\n"
        "  <reg name=\"f26\" bitsize=\"64\" type=\"fputype\" group=\"float\"/>\n"
        "  <reg name=\"f27\" bitsize=\"64\" type=\"fputype\" group=\"float\"/>\n"
        "  <reg name=\"f28\" bitsize=\"64\" type=\"fputype\" group=\"float\"/>\n"
        "  <reg name=\"f29\" bitsize=\"64\" type=\"fputype\" group=\"float\"/>\n"
        "  <reg name=\"f30\" bitsize=\"64\" type=\"fputype\" group=\"float\"/>\n"
        "  <reg name=\"f31\" bitsize=\"64\" type=\"fputype\" group=\"float\"/>\n"
        "  <reg name=\"fcc0\" bitsize=\"8\" type=\"uint8\" group=\"float\"/>\n"
        "  <reg name=\"fcc1\" bitsize=\"8\" type=\"uint8\" group=\"float\"/>\n"
        "  <reg name=\"fcc2\" bitsize=\"8\" type=\"uint8\" group=\"float\"/>\n"
        "  <reg name=\"fcc3\" bitsize=\"8\" type=\"uint8\" group=\"float\"/>\n"
        "  <reg name=\"fcc4\" bitsize=\"8\" type=\"uint8\" group=\"float\"/>\n"
        "  <reg name=\"fcc5\" bitsize=\"8\" type=\"uint8\" group=\"float\"/>\n"
        "  <reg name=\"fcc6\" bitsize=\"8\" type=\"uint8\" group=\"float\"/>\n"
        "  <reg name=\"fcc7\" bitsize=\"8\" type=\"uint8\" group=\"float\"/>\n"
        "  <reg name=\"fcsr\" bitsize=\"32\" type=\"uint32\" group=\"float\"/>\n"
        "</feature>\n",
        41,
    },
    { NULL }
};
